con

'P2 Test Toolbox
'Version 1.93 - Ozpropdev 30th March 2014
'FPGA Build (24th March 2014)


'This demo shows an example of testing a instruction using a data sequence
'and the logger. Press "M=" to run macro

'*******************************************************************************************

	toolbox_rx = 91
	toolbox_tx = 90
	toolbox_baudrate = 19200

dat			orgh	$e00/4			'F11 ro run in Pnut
			org

toolbox_boot		jmp	@toolbox		'Hit <Backspace> to start

'*******************************************************************************************
' *** TEST AREA ***

test_instruction	chkdec	d_reg wc
			jmp	$0		'link return


'Test registers

s_reg			long	0
d_reg			long	0
u_reg			long	0
			long	0
ptr_a			long	0
ptr_b			long	0
ptr_x			long	0
ptr_y			long	0


'*******************************************************************************************

read_cogram		setd	myinda,val2
			nop
			nop
			nop
myinda			pushb	0-0
			reta

start_trace16		neg	dird,#1
			mov	outd,#0
			retd
			clrb	myflags,#trace32
			setrace	#%1111   '16 bit trace on pins 112 to 127
			setxfr	#%1_110_111,#0	'start trace 16 bit
	
start_trace32		neg	dird,#1
			mov	outd,#0
			retd
			setb	myflags,#trace32
			setrace	#%0111   '32 bit trace on pins 96 to 127
			setxfr	#%1_111_111,#0	'start trace 32 bit
	

'*******************************************************************************************

myflags			long	0
elapsed			long	0
enables			long	%1111
option_reg		long	0
cmd			long	0
val			long	0
val2			long	0
zc_flags		long	0
bin_style		long	0
hex_style		long	0
hex_digits		long	0
bin_digits		long	0

entry_mode		long	0
pass			long	0
log			long	0
log_index		long	0
task			long	0
record			long	0
macro_mode		long	0
macro_index		long	0
ptra2			long	0
ptrb2			long	0
mystack_backup		long	0
qreg			long	0
dump_mode		long	0


config			long	%10 << 16 | toolbox_rx << 9 | %10 << 7 | toolbox_tx

test_index		long	0
test_count		long	0

_bad_msg_num		long	@bad_msg

key			long	0
tmp			long	0
toolbox_ax		long	0
toolbox_bx		long	0
toolbox_cx		long	0
toolbox_dx		long	0
toolbox_ex		long	0
toolbox_fx		long	0
res1			long	0
res0			long	0
repeats			long	0

old_s_reg		long	0
old_d_reg		long	0
status			long	0
new_s_reg		long	0
new_d_reg		long	0


'*******************************************************************************************
			orgh

test_data		long	5
			long	"0"
			long	"1"
			long	"9"
			long	"A"
			long	"b"


_tested_		byte	"CHKDEC D ",0

_header_		byte	"Example useage of CHKDEC instruction",0

macro_list		long	@macro_0
			long	@macro_1
			long	@macro_2
			long	@macro_3
			long	@macro_4
			long	@macro_5
			long	@macro_6
			long	@macro_7
			long	@macro_8
			long	@macro_9

macro_0			byte	"l+"		'start logger
			byte	"q^016="	'bo unst,s_reg. Show header
			byte	"'here we go...1234",13
			byte	"*"		'run sequence through instruction
			byte	"L-"
			byte	"v2="		'show results
			byte	"'so there.",13	'comment
			byte	0

macro_1			byte	"k9=k+",0

macro_2			byte	"q^78=r",0

macro_3			byte	"PX23=px|",0
			
macro_4			byte	0
macro_5			byte	0
macro_6			byte	0
macro_7			byte	0
macro_8			byte	0
macro_9			byte	0
	
'*******************************************************************************************
con

	#0,c_flag,z_flag
	#1,dreg,sreg,zflag,cflag,imed,exec,logger,cogram
	hubram,dumpmode,view,effect,user_reg,options,auxdump,trace
	macro_select,ptra_mode,ptrb_mode,ptrx_mode,ptry_mode

	logger_size = 512

	wz_effect = 24
	wc_effect = 23

'option bits

	#0
	hide_inst
	hide_sreg
	show_ureg
	show_etime
	hide_after
	show_header
	show_header_log
	show_ptra_b
	show_ptrx_y

'flags

	#0
	trace32
	ptr_mode
	comment

'*******************************************************************************************
dat
			orgh

toolbox			locptra	@mystack
			locptrb	@mystack2

			loclong	toolbox_bx,@@msg_table


			reps	#256,#1		'fill aux with 0's
			setptry	#0
			wraux	#0,ptry++

			setsera	config,##80_000_000 / toolbox_baudrate	'setip comms
			clrp	#toolbox_tx

			setxch	##$01010101


:loop			serina	key			'press "bacspace" to start
			cmp	key,#8 wz,wc
		if_ne	jmp	@:loop


			pushb	#msg_title
			calla	@show_msg
			calla	@after

'*******************************************************************************************

prompt			clrb	myflags,#ptr_mode
			clrb	myflags,#comment
			cmp	log,#1 wz,wc
		if_e	serouta	#"L"
			cmp	macro_mode,#1 wz,wc
		if_e	serouta	#"m"
			serouta	#">"
			mov	val,#0
			mov	val2,#9
			mov	cmd,#0
			mov	entry_mode,#0
			
wait4key		jz	macro_mode,@w4k

			rdbyte	key,macro_index wz	'process macro
		if_z	mov	macro_mode,#0
		if_z	pushb	#msg_done
		if_z	calla	@show_msg
		if_z	jmp	@prompt
			add	macro_index,#1
			jmp	@w4k_2

w4k			serina	key
w4k_2			chklet	key wc			'check if alpha and make uppercase
		if_nc	jmp	@sym

			testb	myflags,#comment wz
		if_nz	serouta	key
		if_nz	jmp	@wait4key

			mov	tmp,key
			sub	tmp,#"A"

			testb	myflags,#ptr_mode wz
		if_nz	jmp	@ptr_select

			jmplist	tmp,@command_table
command_table		jmp	@hex_entry		'A
			jmp	@hex_entry		'B
			jmp	@hex_entry		'C
			jmp	@hex_entry		'D
			jmp	@hex_entry		'E
			jmp	@hex_entry		'F
			jmp	@command_G		'G Dump COG ram
			jmp	@command_H		'H Dump HUB ram
			jmp	@command_I		'I Immediate
			jmp	@command_J		'J Set DUMP mode
			jmp	@command_K		'K Show TRACE result
			jmp	@command_L		'L Kigger
			jmp	@command_M		'M Run MACRO
			jmp	@command_N		'N Show Header
			jmp	@command_O		'O Execute ONCE with Before/After headers
			jmp	@command_P		'P Wipte TRACE data (Empty AUX ram)
			jmp	@command_Q		'Q Set Options
			jmp	@command_R		'R Refresh
			jmp	@command_S		'S Set SOURCE register
			jmp	@command_T		'T Set DEST register
			jmp	@command_U		'U Set USER register
			jmp	@command_V		'V Vuew logger result
			jmp	@command_W		'W Set WZ and WC effects
			jmp	@command_X		'X Execute n times
			jmp	@command_Y		'Y Set CARRY flag
			jmp	@command_Z		'Z SET ZERO flag

sym			cmp	key,#"=" wz,wc		'load
		if_e	jmp	@load
			cmp	key,#13 wz,wc		'load
		if_e	jmp	@load

			testb	myflags,#comment wz	'comment mode so ignore key
		if_nz	serouta	key
		if_nz	jmp	@wait4key

			cmp	key,#"'" wz,wc		'comment
		if_e	setb	myflags,#comment
		if_e	serouta	key
		if_e	jmp	@wait4key

			cmp	key,#"," wz,wc		'comma
		if_e	mov	val2,val
		if_e	mov	val,#0
		if_e	serouta	#","
		if_e	calla	@show_entry_mode
		if_e	jmp	@wait4key


			cmp	key,#"|" wz,wc		'pipe pointer value
		if_e	serouta	key
		if_e	jmp	@pipe

			cmp	key,#27	wz,wc		'esc = cancel
		if_e	jmp	@prompt

			cmp	key,#"_" wz,wc		'underscore
		if_e	serouta	key
		if_e	jmp	@wait4key


			cmp	key,#"?" wz,wc		'help
		if_e	serouta	key
		if_e	calla	@show_help

			cmp	key,#"+" wz,wc		'increment
		if_e	jmp	@inc

			cmp	key,#"-" wz,wc		'decrement
		if_e	jmp	@dec


			cmp	key,#"#" wz,wc		'dec mode
		if_e	mov	entry_mode,#0
		if_e	calla	@show_entry_mode
		if_e	jmp	@clear

			cmp	key,#"$" wz,wc		'hex mode
		if_e	mov	entry_mode,#1
		if_e	calla	@show_entry_mode
		if_e	jmp	@clear

			cmp	key,#"%" wz,wc		'binary mode
		if_e	mov	entry_mode,#2
		if_e	calla	@show_entry_mode
		if_e	jmp	@clear

			cmp	key,#"^" wz,wc		'bit number mode
		if_e	mov	entry_mode,#3
		if_e	calla	@show_entry_mode
		if_e	jmp	@clear

			cmp	key,#"[" wz,wc		'left align
		if_e	jmp	@left_align

			cmp	key,#"]" wz,wc		'right align
		if_e	jmp	@right_align

			cmp	key,#">" wz,wc		'shift right
		if_e	jmp	@right_shift

			cmp	key,#"<" wz,wc		'shift_left
		if_e	jmp	@left_shift

			cmp	key,#"@" wz,wc		'dump aux ram
		if_e	mov	entry_mode,#1  		'switch to hex mode
		if_e	mov	cmd,#auxdump
		if_e	jmp	@clear

			cmp	key,#"*" wz,wc		'sequence data
		if_e	pushb	#msg_sequence
		if_e	calla	@show_msg
		if_e	jmp	@process_data

			cmp	key,#"/" wz,wc		'remote trace
		if_e	jmp	@remote_trace

			jmplist	entry_mode,@modelist
modelist		jmp	@dec_entry
			jmp	@hex_entry
			jmp	@bin_entry
			jmp	@bit_entry


dec_entry		targ	#tmp
			chkdec	key wc
		if_nc	jmp	@wait4key
			serouta	key
			mov	key,tmp
			mov	tmp,val
			shl	val,#3
			add	val,tmp
			add	val,tmp
			add	val,key
			jmp	@wait4key

hex_entry		cmp	entry_mode,#1 wz,wc
		if_ne	jmp	@wait4key
			targ	#tmp
			chkhex	key wc
		if_nc	jmp	@wait4key
			serouta	key
			shl	val,#4
			add	val,tmp
			jmp	@wait4key

bin_entry		targ	#tmp
			chkdec	key wc
		if_nc	jmp	@wait4key
			cmp	tmp,#1 wz,wc
		if_a	jmp	@wait4key
			serouta	key
			shl	val,#1
			add	val,tmp
			jmp	@wait4key

bit_entry		targ	#tmp
			chkdec	key wc
		if_nc	jmp	@wait4key
			serouta	key
			decod5	tmp
			or	val,tmp
			jmp	@wait4key

'*******************************************************************************************
ptr_select		cmp	key,#"A" wz,wc
		if_e	serouta	key
		if_e	mov	cmd,#ptra_mode
		if_e	jmp	@wait4key

			cmp	key,#"B" wz,wc
		if_e	serouta	key
		if_e	mov	cmd,#ptrb_mode
		if_e	jmp	@wait4key

			cmp	key,#"X" wz,wc
		if_e	serouta	key
		if_e	mov	cmd,#ptrx_mode
		if_e	jmp	@wait4key

			cmp	key,#"Y" wz,wc
		if_e	serouta	key
		if_e	mov	cmd,#ptry_mode
		if_e	jmp	@wait4key

			clrb	myflags,#ptr_mode
			jmp	@wait4key


'*******************************************************************************************
pipe			
			testb	myflags,#ptr_mode wz
		if_e	serouta	#13
		if_z	jmp	@prompt

			mov	hex_digits,#5
			mov	hex_style,#0

			cmp	cmd,#ptra_mode wz,wc
		if_ne	jmp	@pipe2
			serouta	#"$"
			pushb	ptr_a
			calla	@show_hex
			serouta	#13
			mov	tmp,ptr_a
			andn	tmp,#$f
			sub	tmp,#32
			mov	val2,tmp
			mov	val,tmp
			add	val,#79
			jmp	@show_hubram

pipe2			cmp	cmd,#ptrb_mode wz,wc
		if_ne	jmp	@pipe3
			serouta	#"$"
			pushb	ptr_b
			calla	@show_hex
			serouta	#13
			mov	tmp,ptr_b
			andn	tmp,#$f
			sub	tmp,#32
			mov	val2,tmp
			mov	val,tmp
			add	val,#79
			jmp	@show_hubram


pipe3			mov	hex_digits,#2
			cmp	cmd,#ptrx_mode wz,wc
		if_ne	jmp	@pipe4
			serouta	#"$"
			pushb	ptr_x
			calla	@show_hex
			serouta	#13
			mov	val2,ptr_x
			sub	val2,#2
			mov	val,val2
			add	val,#4
			jmp	@aux_dump

pipe4			cmp	cmd,#ptry_mode wz,wc
		if_ne	jmp	@pipe_exit
			serouta	#"$"
			pushb	ptr_y
			calla	@show_hex
			serouta	#13
			mov	val2,ptr_y
			sub	val2,#2
			mov	val,val2
			add	val,#4
			jmp	@aux_dump

pipe_exit		serouta	#13
			jmp	@prompt

'*******************************************************************************************
show_entry_mode		cmp	entry_mode,#0 wz,wc
		if_e	serouta	#"#"
			cmp	entry_mode,#1 wz,wc
		if_e	serouta	#"$"
			cmp	entry_mode,#2 wz,wc
		if_e	serouta	#"%"
			cmp	entry_mode,#3 wz,wc
		if_e	serouta	#"^"
			reta	wc,wz
'*******************************************************************************************

command_G		pushb	#msg_cogram
			calla	@show_msg
			mov	entry_mode,#1  		'switch to hex mode
			calla	@show_entry_mode
			mov	cmd,#cogram
			jmp	@clear

'*******************************************************************************************

command_H		pushb	#msg_hub
			calla	@show_msg
			mov	entry_mode,#1  		'switch to hex mode
			calla	@show_entry_mode
			mov	cmd,#hubram
			jmp	@clear

'*******************************************************************************************

command_I		mov	cmd,#imed
			jmp	@clear

'*******************************************************************************************

command_J		serouta	#"J"
			mov	cmd,#dumpmode
			jmp	@wait4key

'*******************************************************************************************

command_K		pushb	#msg_trace
			calla	@show_msg
			mov	cmd,#trace
			mov	entry_mode,#3   'but entry mode
			calla	@show_entry_mode
			jmp	@clear

'*******************************************************************************************

command_L		serouta	#"L"
			mov	cmd,#logger
			jmp	@clear

'*******************************************************************************************

command_M		serouta	key
			cmp	macro_mode,#1 wz,wc
		if_e	mov	macro_mode,#0
		if_e	serouta	#13
		if_e	pushb	#msg_macro_abort
		if_e	calla	@show_msg
		if_e	jmp	@prompt

			mov	cmd,#macro_select
			jmp	@clear

run_macro		cmp	val,#9 wz,wc
		if_a	jmp	@prompt

			mov	macro_mode,#1
			loclong	val,@@macro_list
			rdlong	macro_index,val
			serouta	#13
			jmp	@prompt

'*******************************************************************************************

command_N		calla	@before
			jmp	@prompt

'*******************************************************************************************

command_O		calla	@before
			serouta	#13
			calla	@execute
			jmp	@prompt

'*******************************************************************************************

command_P		setb	myflags,#ptr_mode
			pushb	#msg_ptr
			calla	@show_msg
			jmp	@wait4key


'*******************************************************************************************

command_Q		pushb	#msg_options
			calla	@show_msg
			mov	cmd,#options
			jmp	@clear

'*******************************************************************************************

command_R		serouta	#"R"
			serouta	#13
			calla	@after
			jmp	@prompt

'*******************************************************************************************

command_S		mov	cmd,#sreg
			pushb	#msg_src
			calla	@show_msg
			calla	@show_entry_mode
			jmp	@clear

'*******************************************************************************************

command_T		mov	cmd,#dreg
			pushb	#msg_dest
			calla	@show_msg
			calla	@show_entry_mode
			jmp	@clear

'*******************************************************************************************

command_U		mov	cmd,#user_reg
			pushb	#msg_user
			calla	@show_msg
			calla	@show_entry_mode
			jmp	@clear

'*******************************************************************************************

command_V		pushb	#msg_view_log
			calla	@show_msg
			mov	cmd,#view
			jmp	@clear			

'*******************************************************************************************

command_W		pushb	#msg_effect
			calla	@show_msg
			mov	cmd,#effect
			jmp	@clear

'*******************************************************************************************

command_X		pushb	#msg_execute
			calla	@show_msg
			mov	cmd,#exec
			jmp	@clear

'*******************************************************************************************

command_Y		pushb	#msg_carry
			calla	@show_msg
			mov	cmd,#cflag
			jmp	@clear

'*******************************************************************************************

command_Z		pushb	#msg_zero
			calla	@show_msg
			mov	cmd,#zflag
			jmp	@clear

'*******************************************************************************************
remote_trace		setxch	##%01010101

			testb	myflags,#trace32 wz
		if_nz	jmp	@capture_32bit

			setxfr	#%1_110_111,#0	'start trace 16 bit
			wait	#500
			setxfr	#0,#0
			jmp	@show_samples

capture_32bit		setxfr	#%1_111_111,#0	'start trace 32 bit
			wait	#250
			setxfr	#0,#0

show_samples		mov	val,#0		'launch view trace,all tasks
			jmp	@show_trace

'*******************************************************************************************

erase_aux		reps	#256,#1
			setptry	#0
			wraux	#0,ptry++
			reta
'*******************************************************************************************

process_data		serouta	#13
			mov	test_index,#0
bug1			locbase	test_index,@@test_data

			rdlong	test_count,test_index wz
		if_z	pushb	#msg_no_test_data
		if_z	calla	@show_msg
		if_z	jmp	@prompt

			mov	hex_digits,#8
			mov	hex_style,#0

:loop			add	test_index,#4

			serouta	#13
			pushb	#msg_data
			calla	@show_msg

			rdlong	d_reg,test_index
			pushb	d_reg
			calla	@show_hex

			serouta	#" "
			serouta	#34
			mov	tmp,d_reg
			and	tmp,#$7f
			cmp	tmp,#32 wz,wc
		if_b	serouta	#"_"
		if_ae	serouta	tmp
			serouta	#34

			serouta	#" "
			pushb	d_reg
			calla	@show_decimal


			serouta	#13

			calla	@execute
			djnz	test_count,@:loop

			jmp	@prompt
'*******************************************************************************************
set_effect		serouta	#13

			cmp	val,#3 wz,wc
		if_a	pushb	#msg_invalid_value
		if_a	calla	@show_msg
		if_a	jmp	@prompt

			jmplist	val,@elist
elist			jmp	@no_effect
			jmp	@set_wc
			jmp	@set_wz

set_wzwc		setb	test_instruction,#wc_effect
			setb	test_instruction,#wz_effect
			calla	@after
			jmp	@prompt

set_wc			setb	test_instruction,#wc_effect
			clrb	test_instruction,#wz_effect
			calla	@after
			jmp	@prompt

set_wz			setb	test_instruction,#wz_effect
			clrb	test_instruction,#wc_effect
			calla	@after
			jmp	@prompt

no_effect		clrb	test_instruction,#wz_effect
			clrb	test_instruction,#wc_effect
			calla	@after
			jmp	@prompt
		

'*******************************************************************************************
left_align		cmp	cmd,#dreg wz,wc
		if_ne	jmp	@la2
			blsize	toolbox_ax,d_reg 
			subr	toolbox_ax,#32
			shl	d_reg,toolbox_ax

la2			cmp	cmd,#sreg wz,wc
		if_ne	jmp	@la3
			blsize	toolbox_ax,s_reg
			subr	toolbox_ax,#32
			shl	s_reg,toolbox_ax

la3			calla	@after
			jmp	@prompt
'*******************************************************************************************
right_align		cmp	cmd,#dreg wz,wc
		if_ne	jmp	@ra2

			botone	toolbox_ax,d_reg
			shr	d_reg,toolbox_ax
			jmp	@ra3

ra2			cmp	cmd,#sreg wz,wc
		if_ne	jmp	@ra3

			botone	toolbox_ax,s_reg
			shr	s_reg,toolbox_ax

ra3			calla	@after
			jmp	@prompt
'*******************************************************************************************

left_shift		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	shl	d_reg,val

			cmp	cmd,#sreg wz,wc
		if_e	shl	s_reg,val

			calla	@after
			jmp	@prompt
'*******************************************************************************************
right_shift		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	shr	d_reg,val

			cmp	cmd,#sreg wz,wc
		if_e	shr	s_reg,val

			calla	@after
			jmp	@prompt
'*******************************************************************************************

inc
			cmp	cmd,#zflag wz,wc
		if_e	pushb	#msg_set
		if_e	calla	@show_msg
		if_e	serouta	#13
		if_e	setb	zc_flags,#z_flag
		if_e	calla	@show_flags
		if_e	jmp	@prompt

			cmp	cmd,#cflag wz,wc
		if_e	pushb	#msg_set
		if_e	calla	@show_msg
		if_e	serouta	#13
		if_e	setb	zc_flags,#c_flag
		if_e	calla	@show_flags
		if_e	jmp	@prompt

			serouta	#"+"

			cmp	cmd,#logger wz,wc
		if_e	mov	log,#1
		if_e	calla	@log_status
		if_e	calla	@prompt


			cmp	cmd,#trace wz,wc
		if_e	setb	myflags,#trace32
		if_e	calla	@show_trace_width
		if_e	jmp	@prompt

			serouta	#13

			cmp	cmd,#options wz,wc
		if_ne	jmp	@inc_main
			cmp	val,#31 wz,wc
		if_a	pushb	#msg_invalid_value
		if_a	calla	@show_msg
		if_a	jmp	@prompt
			setb	option_reg,val
			calla	@show_option_status
			jmp	@prompt

inc_main		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	add	d_reg,val
		if_e	calla	@after

			cmp	cmd,#sreg wz,wc
		if_e	add	s_reg,val
		if_e	calla	@after


			cmp	cmd,#imed wz,wc
		if_e	setb	test_instruction,#22
		if_e	calla	@after

			cmp	cmd,#dumpmode wz,wc
		if_e	incmod	dump_mode,#3
		if_e	calla	@update_dump_mode

			cmp	cmd,#user_reg wz,wc
		if_e	add	u_reg,val
		if_e	calla	@after

			cmp	cmd,#ptra_mode wz,wc
		if_e	add	ptr_a,val
		if_e	calla	@after

			cmp	cmd,#ptrb_mode wz,wc
		if_e	add	ptr_b,val
		if_e	calla	@after

			cmp	cmd,#ptrx_mode wz,wc
		if_e	add	ptr_x,val
		if_e	and	ptr_x,#$ff
		if_e	calla	@after

			cmp	cmd,#ptry_mode wz,wc
		if_e	add	ptr_y,val
		if_e	and	ptr_y,#$ff
		if_e	calla	@after

			jmp	@prompt
'*******************************************************************************************

dec			cmp	cmd,#zflag wz,wc
		if_e	pushb	#msg_cleared
		if_e	calla	@show_msg
		if_e	serouta	#13
		if_e	clrb	zc_flags,#z_flag
		if_e	calla	@show_flags
		if_e	jmp	@prompt

			cmp	cmd,#cflag wz,wc
		if_e	pushb	#msg_cleared
		if_e	calla	@show_msg
		if_e	serouta	#13
		if_e	clrb	zc_flags,#c_flag
		if_e	calla	@show_flags
		if_e	jmp	@prompt


			serouta	#"-"

			cmp	cmd,#logger wz,wc
		if_e	mov	log,#0
		if_e	calla	@log_status
		if_e	calla	@prompt


			cmp	cmd,#trace wz,wc
		if_e	clrb	myflags,#trace32
		if_e	calla	@show_trace_width
		if_e	jmp	@prompt

			serouta	#13

			cmp	cmd,#options wz,wc
		if_ne	jmp	@dec_main
			cmp	val,#31 wz,wc
		if_a	pushb	#msg_invalid_value
		if_a	calla	@show_msg
		if_a	jmp	@prompt
			clrb	option_reg,val
			calla	@show_option_status
			jmp	@prompt

dec_main		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	sub	d_reg,val
		if_e	calla	@after

			cmp	cmd,#sreg wz,wc
		if_e	sub	s_reg,val
		if_e	calla	@after

			cmp	cmd,#imed wz,wc
		if_e	clrb	test_instruction,#22
		if_e	sets	test_instruction,#s_reg
		if_e	calla	@after

			cmp	cmd,#dumpmode wz,wc
		if_e	decmod	dump_mode,#3
		if_e	calla	@update_dump_mode

			cmp	cmd,#user_reg wz,wc
		if_e	sub	u_reg,val
		if_e	calla	@after

			cmp	cmd,#ptra_mode wz,wc
		if_e	sub	ptr_a,val
		if_e	calla	@after

			cmp	cmd,#ptrb_mode wz,wc
		if_e	sub	ptr_b,val
		if_e	calla	@after

			cmp	cmd,#ptrx_mode wz,wc
		if_e	sub	ptr_x,val
		if_e	and	ptr_x,#$ff
		if_e	calla	@after

			cmp	cmd,#ptry_mode wz,wc
		if_e	sub	ptr_y,val
		if_e	and	ptr_y,#$ff
		if_e	calla	@after

			jmp	@prompt

'*******************************************************************************************

load			testb	myflags,#comment wz
		if_nz	serouta	#13
		if_nz	jmp	@prompt

			serouta	#"="
			serouta	#13


			cmp	cmd,#options wz,wc
		if_e	mov	option_reg,val
		if_e	calla	@show_option_status
		if_e	jmp	@prompt

			cmp	cmd,#dreg wz,wc
		if_e	mov	d_reg,val
		if_e	calla	@after

			cmp	cmd,#sreg wz,wc
		if_e	mov	s_reg,val
		if_e	calla	@after

			cmp	cmd,#imed wz,wc
		if_e	setb	test_instruction,#22
		if_e	sets	test_instruction,val
		if_e	calla	@after

			cmp	cmd,#exec wz,wc
		if_e	calla	@execute

			cmp	cmd,#logger wz,wc
		if_ne	jmp	@load_2
			cmp	val,#9 wz,wc
		if_e	mov	log_index,#0
		if_e	calla	@log_status
			jmp	@prompt

load_2			cmp	cmd,#cogram wz,wc
		if_e	jmp	@show_cogram
			
			cmp	cmd,#hubram wz,wc
		if_e	jmp	@show_hubram
		
			cmp	cmd,#view wz,wc
		if_e	jmp	@view_log

			cmp	cmd,#effect wz,wc
		if_e	jmp	@set_effect

			cmp	cmd,#user_reg wz,wc
		if_e	mov	u_reg,val
		if_e	calla	@after

			cmp	cmd,#auxdump wz,wc
		if_e	jmp	@aux_dump

			cmp	cmd,#trace wz,wc
		if_e	jmp	@show_trace

			cmp	cmd,#macro_select wz,wc
		if_e	jmp	@run_macro
	
			cmp	cmd,#ptra_mode wz,wc
		if_e	mov	ptr_a,val
		if_e	calla	@after

			cmp	cmd,#ptrb_mode wz,wc
		if_e	mov	ptr_b,val
		if_e	calla	@after

			cmp	cmd,#ptrx_mode wz,wc
		if_e	and	val,#$ff
		if_e	mov	ptr_x,val
		if_e	calla	@after

			cmp	cmd,#ptry_mode wz,wc
		if_e	and	val,#$ff
		if_e	mov	ptr_y,val
		if_e	calla	@after


			cmp	cmd,#dumpmode wz,wc
		if_ne	jmp	@prompt
			cmp	val,#3 wz,wc
		if_a	pushb	#msg_invalid_value
		if_a	calla	@show_msg
		if_a	jmp	@prompt
			mov	dump_mode,val
			calla	@update_dump_mode
			jmp	@prompt

'*******************************************************************************************
show_trace_width	serouta	#13
			pushb	#msg_trace_width
			calla	@show_msg
			testb	myflags,#trace32 wz
		if_nz	pushb	#msg_32bit
		if_z	pushb	#msg_16bit
			calla	@show_msg
			serouta	#13
			reta	wz,wc
'*******************************************************************************************
show_option_status	pushb	#msg_options
			calla	@show_msg
			serouta	#"="
			mov	toolbox_ax,option_reg
			and	toolbox_ax,##$3ff wz
		if_z	pushb	#msg_off
		if_z	calla	@show_msg
		if_z	serouta	#13
		if_z	jmp	@prompt

			reps	#10,#5
			mov	val,#"0"
			testb	toolbox_ax,#0 wz
		if_nz	serouta	#"_"
		if_nz	serouta	val
			shr	toolbox_ax,#1
			add	val,#1

sos_exit		serouta	#13
			reta	wz,wc

'*******************************************************************************************
update_dump_mode	pushb	#msg_dump_mode
			calla	@show_msg

			cmp	dump_mode,#0 wz,wc
		if_e	pushb	#msg_byte
			cmp	dump_mode,#1 wz,wc
		if_e	pushb	#msg_word
			cmp	dump_mode,#2 wz,wc
		if_e	pushb	#msg_long
			cmp	dump_mode,#3 wz,wc
		if_e	pushb	#msg_text

			calla	@show_msg
			reta

'*******************************************************************************************

view_log		cmp	val,#3 wz,wc
		if_a	pushb	#msg_invalid_view_number
		if_a	calla	@show_msg
		if_a	jmp	@prompt

			jnz	log_index,@@log_exists
			pushb	#msg_log_buffer_empty
			calla	@show_msg
			jmp	@prompt

log_exists		serouta	#13
			testb	option_reg,#show_header_log wz
		if_nz	serouta	#34
		if_nz	pushb	#msg_header
		if_nz	calla	@show_msg
		if_nz	serouta	#34
		if_nz	serouta	#13
		if_nz	serouta	#13

			jmplist	val,@vlist
vlist			jmp	@view0
			jmp	@view1
			jmp	@view2
			jmp	@view3

view0			mov	repeats,log_index
			locbase	toolbox_dx,@@d_buffer

:loop			pushb	#msg_pass
			calla	@show_msg

			rdlong	old_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	old_d_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	status,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_d_reg,toolbox_dx
			add	toolbox_dx,#4

			mov	toolbox_ax,status
			shr	toolbox_ax,#16
			cmp	toolbox_ax,#10 wz,wc
		if_b	serouta	#" "
			pushb	toolbox_ax
			calla	@show_decimal
			serouta	#" "
			serouta	#" "

			serouta	#"S"
			serouta	#"="
			pushb	old_s_reg
			calla	@show_hex
			serouta	#" "

			pushb	status'ex
			calla	@show_zc


			serouta	#" "
			serouta	#" "
			serouta	#"$"
			pushb	new_d_reg 'ex
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex
			serouta	#" "
			serouta	#" "

			serouta	#"%"
			pushb	new_d_reg  'ex
			mov	bin_digits,#32
			mov	bin_style,#2
			calla	@show_binary

			serouta	#" "
			serouta	#" "
			pushb	new_d_reg  'ex
			calla	@show_decimal
		
			
			serouta	#13
			djnz	repeats,@:loop

			jmp	@prompt

'*******************************************************************************************
show_zc			serouta	#"Z"
			serouta	#"C"
			serouta	#"="
			mov	bin_digits,#2
			calla	@show_binary
			reta	wz,wc
'*******************************************************************************************

view1			mov	repeats,log_index
			locbase	toolbox_dx,@@d_buffer

:loop			pushb	#msg_pass
			calla	@show_msg

			rdlong	old_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	old_d_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	status,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_d_reg,toolbox_dx
			add	toolbox_dx,#4

			mov	toolbox_ax,status 'ex
			shr	toolbox_ax,#16
			cmp	toolbox_ax,#10 wz,wc
		if_b	serouta	#" "
			pushb	toolbox_ax
			calla	@show_decimal
			serouta	#" "
			serouta	#" "

			pushb	#msg_tested
			calla	@show_msg

			serouta	#"S"
			serouta	#"="
			serouta	#"$"
			pushb	old_s_reg
			calla	@show_hex
			serouta	#" "

			pushb	#msg_returns
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
			serouta	#"$"
	
			pushb	new_d_reg 'ex
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex
			
			serouta	#13
			djnz	repeats,@:loop

			jmp	@prompt


'*******************************************************************************************

view2			mov	repeats,log_index
			locbase	toolbox_dx,@@d_buffer

:loop			pushb	#msg_pass
			calla	@show_msg

			rdlong	old_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	old_d_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	status,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_d_reg,toolbox_dx
			add	toolbox_dx,#4

			mov	toolbox_ax,status 'ex
			shr	toolbox_ax,#16
			cmp	toolbox_ax,#10 wz,wc
		if_b	serouta	#" "
			pushb	toolbox_ax
			calla	@show_decimal
			serouta	#" "
			serouta	#" "

			pushb	#msg_tested
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
			serouta	#"$"
			pushb	old_d_reg
			calla	@show_hex
			serouta	#" "

			pushb	#msg_returns
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
			serouta	#"$"
	
			pushb	new_d_reg 'ex
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex

			serouta	#" "
			pushb	status
			calla	@show_zc
			
			serouta	#13
			djnz	repeats,@:loop

			jmp	@prompt


'*******************************************************************************************

view3			mov	repeats,log_index
			locbase	toolbox_dx,@@d_buffer

:loop			pushb	#msg_pass
			calla	@show_msg

			rdlong	old_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	old_d_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	status,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_s_reg,toolbox_dx
			add	toolbox_dx,#4
			rdlong	new_d_reg,toolbox_dx
			add	toolbox_dx,#4

			mov	toolbox_ax,status 'ex
			shr	toolbox_ax,#16
			cmp	toolbox_ax,#10 wz,wc
		if_b	serouta	#" "
			pushb	toolbox_ax
			calla	@show_decimal
			serouta	#" "
			serouta	#" "

			pushb	#msg_tested
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
			serouta	#"%"
			pushb	old_d_reg
			calla	@show_binary_trim
			serouta	#" "

			pushb	#msg_returns
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
	
			pushb	new_d_reg 'ex
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_decimal
			
			serouta	#13
			djnz	repeats,@:loop

			jmp	@prompt


'*******************************************************************************************

update_inst		pushb	#msg_inst
			calla	@show_msg
			serouta	#"%"
			pushb	test_instruction
			mov	bin_style,#3
			mov	bin_digits,#32
			calla	@show_binary

			mov	hex_style,#0
			serouta	#" "
			serouta	#"$"
			mov	toolbox_ax,test_instruction
			shr	toolbox_ax,#9
			and	toolbox_ax,#$1ff
			pushb	toolbox_ax
			mov	hex_digits,#3
			calla	@show_hex
	
			serouta	#","
			testb	test_instruction,#22 wz
		if_nz	serouta	#"#"
			serouta	#"$"
			mov	toolbox_ax,test_instruction
			and	toolbox_ax,#$1ff
			pushb	toolbox_ax
			mov	hex_digits,#3
			calla	@show_hex

			serouta	#" "
			mov	toolbox_ax,test_instruction
			shr	toolbox_ax,#9
			and	toolbox_ax,#$1ff
			pushb	toolbox_ax
			calla	@show_decimal

			serouta	#","
			testb	test_instruction,#22 wz
		if_nz	serouta	#"#"
			mov	toolbox_ax,test_instruction
			and	toolbox_ax,#$1ff
			pushb	toolbox_ax
			calla	@show_decimal

			serouta	#13
			reta

'*******************************************************************************************


before			mov	pass,#0
			serouta	#13
			pushb	#msg_title
			calla	@show_msg

			testb	option_reg,#show_header wz
		if_nz	serouta	#34
		if_nz	pushb	#msg_header
		if_nz	calla	@show_msg
		if_nz	serouta	#34
		if_nz	serouta	#13

			pushb	#msg_before
			jmp	#bf2

after			pushb	#msg_after

bf2		'	serouta	#13
			calla	@show_msg


			pushb	#msg_pass
			calla	@show_msg
			pushb	pass
			calla	@show_decimal
			serouta	#" "

			calla	@show_flags


			testb	option_reg,#hide_inst wz
		if_z	calla	@update_inst


compact1		pushb	#msg_dest
			calla	@show_msg
			pushb	d_reg
			calla	@show_reg

			testb	option_reg,#hide_sreg wz
		if_nz	jmp	@:skip2
			pushb	#msg_src
			calla	@show_msg
			pushb	s_reg
			calla	@show_reg

:skip2			testb	option_reg,#show_ureg wz
		if_z	jmp	@:skip3
			pushb	#msg_user
			calla	@show_msg
			pushb	u_reg
			calla	@show_reg


:skip3			testb	option_reg,#show_ptra_b wz
		if_z	jmp	@:skip4

			pushb	#msg_ptr
			calla	@show_msg
			serouta	#"A"
			serouta	#":"
			serouta	#" "
			pushb	ptr_a
			calla	@show_ab

			pushb	#msg_ptr
			calla	@show_msg
			serouta	#"B"
			serouta	#":"
			serouta	#" "
			pushb	ptr_b
			calla	@show_ab

:skip4			testb	option_reg,#show_ptrx_y wz
		if_z	jmp	@:skip5

			pushb	#msg_ptr
			calla	@show_msg
			serouta	#"X"
			serouta	#":"
			serouta	#" "
			pushb	ptr_x
			calla	@show_xy

			pushb	#msg_ptr
			calla	@show_msg
			serouta	#"Y"
			serouta	#":"
			serouta	#" "
			pushb	ptr_y
			calla	@show_xy

:skip5		'	serouta	#13
			reta	wz,wc

'*******************************************************************************************

log_status		serouta	#13
			pushb	#msg_log
			calla	@show_msg
			cmp	log,#1 wz,wc
		if_e	pushb	#msg_on	
		if_ne	pushb	#msg_off
			calla	@show_msg
			serouta	#" "
			pushb	#msg_index
			calla	@show_msg
			pushb	log_index
			calla	@show_decimal
			serouta	#13
			reta	wz,wc

'*******************************************************************************************


show_ab			popb	qreg
			pushb	qreg
			serouta	#"$"
			mov	hex_style,#0
			mov	hex_digits,#5
			calla	@show_hex
			serouta	#":"
			serouta	#" "

			rdlong	toolbox_ax,qreg
			pushb	toolbox_ax
			mov	hex_style,#1
			mov	hex_digits,#8
			calla	@show_hex
			serouta	#" "

			rdword	toolbox_ax,qreg
			pushb	toolbox_ax
			mov	hex_style,#1
			mov	hex_digits,#4
			calla	@show_hex
			serouta	#" "

			rdbyte	toolbox_ax,qreg
			mov	tmp,toolbox_ax
			pushb	toolbox_ax
			mov	hex_style,#1
			mov	hex_digits,#2
			calla	@show_hex
			serouta	#" "

			serouta	#34
			and	tmp,#$7f
			cmp	tmp,#32 wz,wc
		if_b	serouta	#"_"
		if_ae	serouta	tmp
			serouta	#34
			serouta	#" "
			serouta	#" "

			serouta	#13
			reta

'*******************************************************************************************
show_xy			popb	qreg
			pushb	qreg

			serouta	#"$"
			mov	hex_digits,#2
			mov	hex_style,#1
			calla	@show_hex
			serouta	#":"
			serouta	#" "

			rdaux	toolbox_ax,qreg
			pushb	toolbox_ax
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex

			serouta	#" "
			serouta	#"!"

			xor	qreg,#$ff
			pushb	qreg
			serouta	#"$"
			mov	hex_digits,#2
			mov	hex_style,#1
			calla	@show_hex
			serouta	#":"
			serouta	#" "

			rdaux	toolbox_ax,qreg
			pushb	toolbox_ax
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex



			serouta	#13
			reta
'*******************************************************************************************

show_reg		popb	qreg

			serouta	#"$"
			mov	hex_style,#1
			pushb	qreg
			mov	hex_digits,#8
			calla	@show_hex
			serouta	#" "
			serouta	#" "

			serouta	#"%"
			mov	bin_style,#2
			pushb	qreg
			mov	bin_digits,#32
			calla	@show_binary
			serouta	#" "
			serouta	#" "

			serouta	#34
			mov	tmp,qreg
			and	tmp,#$7f
			cmp	tmp,#32 wz,wc
		if_b	serouta	#"_"
		if_ae	serouta	tmp
			serouta	#34
			serouta	#" "

			pushb	qreg
			calla	@show_decimal
			testb	qreg,#31 wz
		if_z	serouta	#13
		if_z	reta

			serouta	#" "
			serouta	#" "
			neg	toolbox_ax,qreg
			pushb	toolbox_ax
			serouta	#"-"
			calla	@show_decimal
			serouta	#13

			reta

'*******************************************************************************************

show_flags		pushb	#msg_flags
			calla	@show_msg
			serouta	#"Z"
			serouta	#"="
			testb	zc_flags,#z_flag wz
		if_z	serouta	#"0"
		if_nz	serouta	#"1"
			serouta	#" "
			serouta	#"C"
			serouta	#"="
			testb	zc_flags,#c_flag wz
		if_z	serouta	#"0"
		if_nz	serouta	#"1"
			serouta	#13
			reta
'*******************************************************************************************

execute			getptra	mystack_backup

			mov	repeats,val
			mins	repeats,#1
			maxs	repeats,##logger_size

exec_loop		jz	log,@:loop3
			locbase	toolbox_fx,@@d_buffer	'update logger
			mov	toolbox_ax,log_index
			mul	toolbox_ax,#20
			add	toolbox_fx,toolbox_ax
			wrlong	s_reg,toolbox_fx
			add	toolbox_fx,#4
			wrlong	d_reg,toolbox_fx
			add	toolbox_fx,#4
	
:loop3			getptra	ptra2
			getptrb	ptrb2

			setptra	ptr_a
			setptra	ptr_b
			setptrx	ptr_x
			setptry	ptr_y

			popzc	zc_flags wz,wc
			link	#test_instruction
			pushzc	zc_flags

			getptra	ptr_a
			getptrb	ptr_b
			getptrx	ptr_x
			getptry	ptr_y

			setptra	ptra2
			setptrb	ptrb2

			add	pass,#1

			jz	log,@:loop2
			mov	toolbox_ax,pass		'update logger
			shl	toolbox_ax,#16
			or	toolbox_ax,zc_flags
			wrlong	toolbox_ax,toolbox_fx
			add	toolbox_fx,#4
			wrlong	s_reg,toolbox_fx
			add	toolbox_fx,#4
			wrlong	d_reg,toolbox_fx
			add	toolbox_fx,#4
			incmod	log_index,##logger_size wc
		if_c	mov	log,#0
		
:loop2			testb	option_reg,#hide_after wz
		if_z	setptra	mystack_backup
		if_z	calla	@after

			serouta	#13			

			djnz	repeats,@exec_loop

			mul	elapsed,#125	'12.5nS per cycle @ 80MHz

			testb	option_reg,#show_etime wz
		if_nz	calla	@show_elapsed
			
			reta	wz,wc

'*******************************************************************************************

clear			mov	val,#0
			mov	val2,#0
			jmp	@wait4key

'*******************************************************************************************

show_hex		locbase	toolbox_cx,@@hex_formats
			mov	toolbox_bx,hex_style
			shl	toolbox_bx,#2
			add	toolbox_cx,toolbox_bx
			rdlong	toolbox_fx,toolbox_cx

			jnz	hex_digits,@:setup
			mov	hex_digits,#8

:setup			mov	toolbox_bx,hex_digits
			shl	toolbox_bx,#2
			subr	toolbox_bx,#32

			cmp	hex_digits,#8 wz,wc
		if_ne	pushb	hex_digits
		if_ne	calla	@set_start

			popb	toolbox_ax

			shl	toolbox_ax,toolbox_bx

:loop			rdbyte	toolbox_bx,toolbox_fx wz
			add	toolbox_fx,#1
		if_z	reta
			cmp	toolbox_bx,#"d" wz,wc
		if_e	jmp	@:loop2
			serouta	toolbox_bx
			jmp	@:loop

:loop2			getnib	toolbox_bx,toolbox_ax,#7
			cmp	toolbox_bx,#9 wz,wc
		if_be	add	toolbox_bx,#"0"
		if_a	add	toolbox_bx,#"A"-10
			serouta	toolbox_bx
			shl	toolbox_ax,#4
			jmp	@:loop

'*******************************************************************************************
set_start		popb	toolbox_cx

:findz			rdbyte	toolbox_ax,toolbox_fx  wz
			add	toolbox_fx,#1
		if_nz	jmp	@:findz		'find 0 terminator
			sub	toolbox_fx,#2

:loop			rdbyte	toolbox_ax,toolbox_fx wz
			sub	toolbox_fx,#1
		if_z	add	toolbox_fx,#1
		if_z	reta
			cmp	toolbox_ax,#"d" wz,wc
		if_ne	jmp	@:loop
			djnz	toolbox_cx,@:loop
			add	toolbox_fx,#1
			reta

'*******************************************************************************************
show_binary_trim	rdlong	toolbox_ax,ptrb[-1]
			blsize	bin_digits,toolbox_ax

show_binary		locbase	toolbox_cx,@@bin_formats
			mov	toolbox_bx,bin_style
			shl	toolbox_bx,#2
			add	toolbox_cx,toolbox_bx
			rdlong	toolbox_fx,toolbox_cx

			jnz	bin_digits,@:setup
			mov	bin_digits,#32

:setup			mov	toolbox_bx,bin_digits
			subr	toolbox_bx,#32

			cmp	bin_digits,#32 wz,wc
		if_ne	pushb	bin_digits
		if_ne	calla	@set_start

			popb	toolbox_ax
			shl	toolbox_ax,toolbox_bx


:loop			rdbyte	toolbox_bx,toolbox_fx wz
			add	toolbox_fx,#1
		if_z	reta
			cmp	toolbox_bx,#"d" wz,wc
		if_e	jmp	@:loop2
			serouta	toolbox_bx
			jmp	@:loop

:loop2			testb	toolbox_ax,#31 wz
		if_z	serouta	#"0"
		if_nz	serouta	#"1"
			shl	toolbox_ax,#1
			jmp	@:loop
'*******************************************************************************************

show_decimal		mov	res1,#0
			mov	res0,#0
			popb	toolbox_ax

			mov	toolbox_cx,#32
:loop			shl	toolbox_ax,#1 wc
			binbcd	res0 wc
			binbcd	res1
			djnz	toolbox_cx,@:loop

			pushb	res0
			pushb	res1
			or	res1,#0 wz
		if_z	popb	res1
		if_nz	calla	@trimmed_hex
			calla	@trimmed_hex
			reta	wz,wc

'*******************************************************************************************
			
trimmed_hex		popb	toolbox_ax
			topone	toolbox_bx,toolbox_ax wc		'get magnitude
		if_c	serouta	#"0"
		if_c	reta
			shr	toolbox_bx,#2
			add	toolbox_bx,#1			'digits
			mov	toolbox_cx,toolbox_bx
			shl	toolbox_cx,#2
			subr	toolbox_cx,#32			'shift
			shl	toolbox_ax,toolbox_cx		
:loop			getnib	tmp,toolbox_ax,#7
			cmp	tmp,#9 wz,wc
		if_be	add	tmp,#"0"
		if_a	add	tmp,#"A"-10
			serouta	tmp
			shl	toolbox_ax,#4
			djnz	toolbox_bx,@:loop
			reta	wz,wc

'*******************************************************************************************
show_help		cmp	cmd,#options wz,wc
		if_e	jmp	@show_option_help

			cmp	cmd,#dumpmode wz,wc
		if_e	jmp	@show_dumpmode_help

			testb	myflags,#ptr_mode wz
		if_nz	jmp	@show_ptr_help

			cmp	cmd,#effect wz,wc
		if_e	jmp	@show_effect_help

			cmp	cmd,#logger wz,wc
		if_e	calla	@log_status
		if_e	jmp	@prompt

			cmp	cmd,#trace wz,wc
		if_e	calla	@show_trace_width
		if_e	jmp	@prompt

			pushb	#msg_help
			calla	@show_msg
			jmp	@prompt

show_option_help	pushb	#msg_option_help
			calla	@show_msg
			calla	@show_option_status
			jmp	@prompt

show_dumpmode_help	pushb	#msg_dump_mode_help
			calla	@show_msg
			calla	@update_dump_mode
			jmp	@prompt

show_ptr_help		pushb	#msg_ptr_help
			calla	@show_msg
			jmp	@prompt

show_effect_help	pushb	#msg_effect_help
			calla	@show_msg
			jmp	@prompt

'*******************************************************************************************
show_trace		cmp	val,##512 wz,wc
		if_e	calla	@erase_aux
		if_e	pushb	#msg_done
		if_e	calla	@show_msg
		if_e	jmp	@prompt

			mov	record,#0
			serouta	#13

			mov	enables,val wz
		if_z	mov	enables,#%1111

			mov	bin_digits,#16
			mov	bin_style,#4

			setptry	#$ff
			mov	repeats,#256
:look4end		rdaux	toolbox_ex,ptry-- wz
		if_nz	jmp	@l4e
			djnz	repeats,@:look4end 
			jnz	repeats,@l4e
			mov	repeats,#256

l4e			setptry	#0

:loop			rdaux	val2,ptry++
			pushb	val2
			calla	@show_trace_line

			testb	myflags,#trace32 wz
		if_nz	jmp	@:loop2

			shr	val2,#16
			pushb	val2
			calla	@show_trace_line

:loop2			calla	@esc_check
		if_e	jmp	@:exit

			djnz	repeats,@:loop

:exit			setptry	val
			jmp	@prompt

'*******************************************************************************************

show_trace_line		testb	myflags,#trace32 wz
		if_nz	jmp	@show_trace32

'16 bit trace mode
			popb	cmd
			add	record,#1

			and	cmd,##$ffff

			mov	toolbox_ex,cmd
			shr	toolbox_ex,#14
			decod5	toolbox_ex,toolbox_ex
			and	toolbox_ex,enables wz
		if_z	reta

			serouta	#"R"
			pushb	record
			calla	@show_decimal
			cmp	record,#10 wz,wc
		if_b	serouta	#" "
			cmp	record,#100 wz,wc
		if_b	serouta	#" "

			serouta	#" "

			pushb	#msg_task
			calla	@show_msg
			mov	task,cmd
			shr	task,#14
			and	task,#3
			mov	toolbox_ax,task
			add	toolbox_ax,#"0"
			serouta	toolbox_ax
			serouta	#" "

			testb	cmd,#13 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_hub
			calla	@show_msg

			testb	cmd,#12 wz
		if_z	pushb	#msg_dash5
		if_nz	pushb	#msg_fetch
			calla	@show_msg

			testb	cmd,#11 wz
		if_nz	pushb	#msg_dash5
		if_z	pushb	#msg_stall
			calla	@show_msg

			testb	cmd,#10 wz
		if_nz	pushb	#msg_dash4
		if_z	pushb	#msg_skip
			calla	@show_msg

			testb	cmd,#9 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_jump
			calla	@show_msg

			serouta	#" "
			serouta	#"|"
			serouta	#" "

			jz	task,@show_task_pc
			mov	toolbox_dx,task
:loop			pushb	#msg_dash4
			calla	@show_msg
			djnz	toolbox_dx,@:loop

show_task_pc		serouta	#"$"
			mov	toolbox_ax,cmd
			and	toolbox_ax,#$1ff
			pushb	toolbox_ax
			mov	hex_digits,#3
			calla	@show_hex
			serouta	#" "

			cmp	task,#3 wz,wc
		if_e	jmp	@no_dash
			subr	task,#3
			
:loop2			pushb	#msg_dash4
			calla	@show_msg
			djnz	task,@:loop2


no_dash			serouta	#13
			
			reta

'*******************************************************************************************

show_trace32		popb	cmd
			add	record,#1


			mov	toolbox_ex,cmd
			shr	toolbox_ex,#30
			decod5	toolbox_ex,toolbox_ex
			and	toolbox_ex,enables wz
		if_z	reta

			mov	hex_style,#0

			serouta	#"R"
			pushb	record
			calla	@show_decimal
			cmp	record,#10 wz,wc
		if_b	serouta	#" "
			cmp	record,#100 wz,wc
		if_b	serouta	#" "

			serouta	#" "

			pushb	#msg_task
			calla	@show_msg
			mov	task,cmd
			shr	task,#30
			and	task,#3
			mov	toolbox_ax,task
			add	toolbox_ax,#"0"
			serouta	toolbox_ax
			serouta	#" "

			testb	cmd,#29 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_hub
			calla	@show_msg

			testb	cmd,#28 wz
		if_z	pushb	#msg_dash5
		if_nz	pushb	#msg_fetch
			calla	@show_msg

			testb	cmd,#27 wz
		if_nz	pushb	#msg_dash5
		if_z	pushb	#msg_stall
			calla	@show_msg

			testb	cmd,#26 wz
		if_nz	pushb	#msg_dash4
		if_z	pushb	#msg_skip
			calla	@show_msg

			testb	cmd,#25 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_jump
			calla	@show_msg


			testb	cmd,#24 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_unknown
			calla	@show_msg


			testb	cmd,#23 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_unknown
			calla	@show_msg


			testb	cmd,#22 wz
		if_z	pushb	#msg_dash5
		if_nz	pushb	#msg_video
			calla	@show_msg

			testb	cmd,#21 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_ctra
			calla	@show_msg

			testb	cmd,#20 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_ctrb
			calla	@show_msg

			testb	cmd,#19 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_rxa
			calla	@show_msg

			testb	cmd,#18 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_txa
			calla	@show_msg

			testb	cmd,#17 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_rxb
			calla	@show_msg

			testb	cmd,#16 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_txb
			calla	@show_msg

			serouta	#" "
			serouta	#"|"
			serouta	#" "

			jz	task,@show_task_pc2
			mov	toolbox_dx,task
:loop			pushb	#msg_dash5
			calla	@show_msg
			djnz	toolbox_dx,@:loop

show_task_pc2		serouta	#"$"
			mov	toolbox_ax,cmd
			and	toolbox_ax,##$3ffff
			pushb	toolbox_ax
			mov	hex_digits,#4
			calla	@show_hex
			serouta	#" "

			cmp	task,#3 wz,wc
		if_e	jmp	@no_dash2
			subr	task,#3
			
:loop2			pushb	#msg_dash5
			calla	@show_msg
			djnz	task,@:loop2


no_dash2		serouta	#13
			reta

'*******************************************************************************************
show_cogram		serouta	#13

			sub	val,val2
			add	val,#1

:loop			pushb	#msg_cogram
			calla	@show_msg

			serouta	#"$"
			pushb	val2
			mov	hex_digits,#3
			calla	@show_hex
			serouta	#":"
			serouta	#"="
			serouta	#" "

			calla	#read_cogram
			serouta	#"$"
			mov	hex_digits,#8
			calla	@show_hex
			serouta	#" "

			serouta	#"%"
			calla	#read_cogram
			mov	bin_style,#3
			mov	bin_digits,#32
			calla	@show_binary
			serouta	#" "

			calla	#read_cogram
			calla	@show_decimal

			add	val2,#1

			serouta	#13
			djnz	val,@:loop			

			jmp	@prompt

'*******************************************************************************************
esc_check		serina	toolbox_ax wc
		if_c	reta
			cmp	toolbox_ax,#27 wz,wc
			reta
'*******************************************************************************************
show_hubram		mov	cmd,#0

			jmplist	dump_mode,@dlist
dlist			jmp	@byte_dump
			jmp	@word_dump
			jmp	@long_dump
			jmp	@text_dump

'*******************************************************************************************

byte_dump		and	val2,##$ffff0

			sub	val,val2
			add	val,#1
			
:loop			test	val2,#$f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdbyte	toolbox_ax,val2
			add	val2,#1
			pushb	toolbox_ax
			mov	hex_digits,#2
			calla	@show_hex
			serouta	#" "
			incmod	cmd,#15 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop
:exit			serouta	#13
	
			jmp	@prompt
'*******************************************************************************************

word_dump		and	val2,##$ffff8

			sub	val,val2
			add	val,#1
			shr	val,#1
			
:loop			test	val2,#$f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdword	toolbox_ax,val2
			add	val2,#2
			pushb	toolbox_ax
			mov	hex_digits,#4
			calla	@show_hex
			serouta	#" "
			serouta	#" "
			incmod	cmd,#7 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop

:exit			serouta	#13
	
			jmp	@prompt
'*******************************************************************************************

long_dump		and	val2,##$ffffc

			sub	val,val2
			add	val,#1
			shr	val,#2
			
:loop			test	val2,#$f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdlong	toolbox_ax,val2
			add	val2,#4
			pushb	toolbox_ax
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex
			serouta	#" "
			serouta	#" "
			incmod	cmd,#3 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop

:exit			serouta	#13
	
			jmp	@prompt

'*******************************************************************************************

text_dump		and	val2,##$ffff0

			sub	val,val2
			add	val,#1

:loop			test	val2,#$1f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdbyte	toolbox_ax,val2
			add	val2,#1

			cmp	toolbox_ax,#32 wz,wc
		if_b	mov	toolbox_ax,#"."
			cmp	toolbox_ax,#127 wz,wc
		if_a	mov	toolbox_ax,#"."
			serouta	toolbox_ax
	
			incmod	cmd,#31 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop
:exit			serouta	#13

			jmp	@prompt

'*******************************************************************************************
aux_dump		getptry	cmd
			setptry	#0

			mov	toolbox_ax,val
			or	toolbox_ax,val2 wz
		if_z	mov	repeats,#256
		if_z	setptry	#0
		if_z	jmp	@:loop

			setptry	val2
			mov	repeats,val
			sub	repeats,val2 wz
			add	repeats,#1
			mins	repeats,#1
			maxs	repeats,#256
		

:loop			serouta	#"A"
			serouta	#"u"
			serouta	#"x"
			serouta	#" "
			serouta	#"$"

			getptry	toolbox_ax
			pushb	toolbox_ax
			mov	hex_digits,#2
			calla	@show_hex
			serouta	#":"	
			serouta	#" "

			serouta	#"$"
			rdaux	toolbox_ax,ptry
			pushb	toolbox_ax
			mov	hex_style,#1
			mov	hex_digits,#8
			calla	@show_hex
			serouta	#" "

			serouta	#"%"
			rdaux	toolbox_ax,ptry++
			pushb	toolbox_ax
			mov	bin_digits,#32
			mov	bin_style,#5
			calla	@show_binary

			serouta	#13
			
			calla	@esc_check
		if_e	jmp	@:exit


			djnz	repeats,@:loop

:exit			setptry	cmd
			jmp	@prompt

'*******************************************************************************************

error			pushb	#msg_error
			calla	@show_msg
			jmp	@prompt

'*******************************************************************************************

show_elapsed		pushb	#msg_elapsed
			calla	@show_msg

			cmp	elapsed,##9999 wz,wc
		if_be	jmp	@show_ns


show_us			calla	@div_10000
			pushb	elapsed
			calla	@show_decimal
			serouta	#"."

			cmp	toolbox_ex,##1000 wz,wc
		if_b	serouta	#"0"
			cmp	toolbox_ex,#100 wz,wc
		if_b	serouta	#"0"
			cmp	toolbox_ex,#10 wz,wc
		if_b	serouta	#"0"   

			pushb	toolbox_ex
			calla	@show_decimal
			pushb	#msg_us	
			calla	@show_msg
			serouta	#13
			reta

show_ns			calla	@div_10
			pushb	elapsed
			calla	@show_decimal
			serouta	#"."
			pushb	toolbox_ex
			calla	@show_decimal
			pushb	#msg_ns
			calla	@show_msg
			serouta	#13
			reta	

'*******************************************************************************************
div_10			mov	toolbox_ex,elapsed
			mov	elapsed,#0
:loop			cmpsub	toolbox_ex,#10 wz,wc
		if_c	add	elapsed,#1
		if_c	jmp	@:loop
			reta
'*******************************************************************************************
div_10000		mov	toolbox_ex,#0
			cmp	elapsed,##9999 wz,wc
		if_be	reta

			mov	toolbox_ex,elapsed
			mov	elapsed,#0
:loop			cmpsub	toolbox_ex,##10_000 wz,wc
		if_c	add	elapsed,#1
		if_c	jmp	@:loop
			reta

'*******************************************************************************************

show_msg		popb	toolbox_bx

			cmp	toolbox_bx,#last_msg wz,wc
		if_ae	mov	toolbox_bx,_bad_msg_num
		if_ae	jmp	@show_msg_direct

bug			loclong	toolbox_bx,@msg_table

			rdlong	toolbox_bx,toolbox_bx

show_msg_direct		rdbyte	toolbox_ex,toolbox_bx wz
			add	toolbox_bx,#1
		if_z	reta	wz,wc
			serouta	toolbox_ex
			jmp	@show_msg_direct

msg_table		long	@bad_msg
			long	@_title_	'msg title
			long	@_done_		'msg_done
			long	@_byte_		'msg_byte
			long	@_word_		'msg_word
			long	@_long_		'msg_long
			long	@_text_		'msg_text
			long	@_pass_		'msg_pass
			long	@_tested_	'msg_tested
			long	@_returns_	'msg_returns
			long	@_inst_		'msg_inst
			long	@_before_	'msg_before
			long	@_after_	'msg_after
			long	@_log_		'msg_log
			long	@_on_		'msg_on
			long	@_off_		'msg_off
			long	@_dump_		'msg_dump
			long	@_flags_	'msg_flags
			long	@help		'msg_help
			long	@_task_		'msg_task
			long	@_hub_		'msg_hub
			long	@_dash3_	'msg_dash3
			long	@_dash5_	'msg_dash5
			long	@_fetch_	'msg_fetch
			long	@_stall_	'msg_stall
			long	@_dash4_	'msg_dash4
			long	@_skip_		'msg_skip
			long	@_jump_		'msg_jump
			long	@_unknown_	'msg_inknown
			long	@_vidack_	'msg_video
			long	@_ctra_		'msg_ctra
			long	@_ctrb_		'msg_ctrb
			long	@_rxa_		'msg_rxa
			long	@_txa_		'msg+txa
			long	@_rxb_		'msg_rxb
			long	@_txb_		'msg+txb
			long	@_cogram_	'msg_cogram
			long	@_error_	'msg_error
			long	@_ms_		'msg_ms
			long	@_us_		'msg_us
			long	@_header_	'msg_header
			long	@_elapsed_	'msg_elapsed
			long	@_ns_		'msg_ns

			long	@_log_buffer_empty
			long	@_invalid_view_number
			long	@_invalid_value
			long	@_macro_abort
			long	@_no_test_data

			long	@_src
			long	@_dest
			long	@_user
			long	@_ptr

			long	@_trace_
			long	@_options_
			long	@option_help
			long	@_carry_
			long	@_zero_
			long	@_set_
			long	@_cleared_
			long	@dumpmode_help
			long	@ptr_help
			long	@effect_help
			long	@_effect_
			long	@_execute_
			long	@_index_
			long	@_sequence_
			long	@_data_
			long	@_view_log_
			long	@_trace_width_
			long	@_32bit
			long	@_16bit
'*******************************************************************************************
			
_title_			byte	"P2 Test Toolbox V1.93",13,13,0
_before_		byte	"Before:  ",0
_after_			byte	"After:   ",0
_inst_			byte	"Instruction: ",0
_flags_			byte	"Flags: ",0
_pass_			byte	"Pass #",0
_log_			byte	"  Log: ",0
_off_			byte	"OFF",0
_on_			byte	"ON",0
_cogram_		byte	"Cog Ram ",0
_returns_		byte	"returns ",0

_task_			byte	"TASK",0
_hub_			byte	"HUB ",0
_fetch_			byte	"FETCH ",0
_go_			byte	"GO ",0
_stall_			byte	"STALL ",0
_cond_			byte	"COND ",0
_skip_			byte	"SKIP ",0
_jump_			byte	"JUMP ",0
_dash2_			byte	"-- ",0
_dash3_			byte	"--- ",0
_dash4_			byte	"---- ",0
_dash5_			byte	"----- ",0
_done_			byte	13,"Done.",13,0
_vidack_		byte	"VIDEO ",0
_ctra_			byte	"CTRA ",0
_ctrb_			byte	"CTRB ",0
_rxa_			byte	"RXA ",0
_txa_			byte	"TXA ",0
_rxb_			byte	"RXB ",0
_txb_			byte	"TXB ",0
_byte_			byte	"BYTE",13,0
_word_			byte	"WORD",13,0
_long_			byte	"LONG",13,0
_text_			byte	"TEXT",13,0
_dump_			byte	"Dump mode:",0
_unknown_		byte	"??? ",0
_error_			byte	"Error",13,0
_us_			byte	"uS",0
_ms_			byte	"mS",0
_ns_			byte	"nS",0
_elapsed_		byte	"Elapsed = ",0
bad_msg			byte	"** Bad Msg num *** ",0

_log_buffer_empty	byte	"Log buffer empty",13,0
_invalid_view_number	byte	"Invalid view number",13,0
_invalid_value		byte	"Invalid value",13,0
_macro_abort		byte	"Macro abort",13,0
_no_test_data		byte	"No test data",13,0

_src			byte	"S_REG:",0
_dest			byte	"D_REG:",0
_user			byte	"U_REG:",0
_ptr			byte	"PTR",0
_trace_			byte	"TRACE ",0
_options_		byte	"OPTIONS ",0

_carry_			byte	"Carry ",0
_zero_			byte	"zero ",0
_set_			byte	"Set",0
_cleared_		byte	"Cleared",0
_effect_		byte	"Effect ",0
_execute_		byte	"Execute ",0
_index_			byte	"Index :",0
_sequence_		byte	"Sequence ",0
_data_			byte	"Data :",0
_view_log_		byte	"View Log: ",0
_trace_width_		byte	"Trace width ",0
_32bit			byte	"32 bit",0
_16bit			byte	"16 bit",0
'========================================================================================

bin_formats		long	@bin_format0 
			long	@bin_format1 
			long	@bin_format2 
			long	@bin_format3 
			long	@bin_format4 
			long	@bin_format5

hex_formats		long	@hex_format0 
			long	@hex_format1 
			long	@hex_format2 

bin_format0		byte	"dddddddddddddddddddddddddddddddd",0
bin_format1		byte	"dddddddd_dddddddd_dddddddd_dddddddd",0
bin_format2		byte	"dddd_dddd_dddd_dddd_dddd_dddd_dddd_dddd",0
bin_format3		byte	"ddddddd_dd_d_dddd_ddddddddd_ddddddddd",0
bin_format4		byte	"dd_d_d_d_d_d_ddddddddd",0
bin_format5		byte	"dddddddddddddddd_dddddddddddddddd",0

hex_format0		byte	"dddddddd",0
hex_format1		byte	"dddd_dddd",0
hex_format2		byte	"dd_dd_dd_dd",0

'========================================================================================
help			byte	13
			byte	"P2 Test Toolbox commands",13,13
			byte	"0..9         Decimal digits",13
			byte	"A..F         Hex digits",13
			byte	"$            Hex entry mode",13
			byte	"%            Binary entry mode",13
			byte	"#            Decimal entry mode",13
			byte	"^            Bit number entry mode",13
			byte	"= or ENTER   Load register",13
			byte	"+            Increment/Add to register",13
			byte	"-            Decrement/Sub from  register",13
			byte	"<            Left shift register",13
			byte	">            Right shift register",13
			byte	"[            Left align register",13
			byte	"]            Right align register",13
			byte	"Z            ZERO flag",13
			byte	"Y            CARRY flag",13
			byte	"T            DEST register",13
			byte	"S            SOURCE register",13
			byte	"I            IMMEDIATE",13
			byte	"N            Show Before Header, zeroes pass counter",13
			byte	"X            Execute instruction",13
			byte	"O            Execute once with before/after headers",13
			byte	"*            Execute with test data",13
			byte	"R            Refresh",13
			byte	"L            Logger",13
			byte	"V            View logger results",13
			byte	"K            Vuew trace results",13
			byte	"P            Pointer select",13
			byte	"G            Dump COG ram",13
			byte	"H            Dump HUB ram",13
			byte	"J            Change Hub dump mode",13
			byte	"W            Set/Clear effect",13
			byte	"U            USER register",13
			byte	"@            Dump AUX ram",13
			byte	"Q            Options",13
			byte	"*            Load data sequence",13
			byte	"/            Captire TRACE data",13
			byte	0

option_help		byte	13
			byte	" 0 - Hide Instruction",13
			byte	" 1 - Hide s_reg",13
			byte	" 2 - Show u_reg",13
			byte	" 3 - Show elapsed",13
			byte	" 4 - Hude After: (Execute)",13
			byte	" 5 - Show header with title",13
			byte	" 6 - Show header in log results",13
			byte	" 7 - Show PTRA/B registers",13
			byte	" 8 - Show PTRX/Y registers",13
			byte	" 9 - spare",13
			byte	0

dumpmode_help		byte	13
			byte	" 0 - BYTE",13
			byte	" 1 - WORD",13
			byte	" 2 - LONG",13
			byte	" 3 - TEXT",13
			byte	0

ptr_help		byte	13
			byte	" A - PTRA",13
			byte	" B - PTRB",13
			byte	" X - PTRX",13
			byte	" Y - PTRY",13
			byte	0

effect_help		byte	13
			byte	" 0 - No WZ,WC effects",13
			byte	" 1 - WC effect set",13
			byte	" 2 - WZ effect set",13
			byte	" 3 - Both WZ,WC set",13
			byte	0

'========================================================================================

mystack			long	0[16]

mystack2		long	0[16]

d_buffer		long	0[logger_size*5]

special_buffer		long	0[8*200]

con

	#1
	msg_title
	msg_done
	msg_byte
	msg_word
	msg_long
	msg_text
	msg_pass
	msg_tested
	msg_returns
	msg_inst
	msg_before
	msg_after
	msg_log
	msg_on
	msg_off
	msg_dump_mode
	msg_flags
	msg_help
	msg_task
	msg_hub
	msg_dash3
	msg_dash5
	msg_fetch
	msg_stall
	msg_dash4
	msg_skip
	msg_jump
	msg_unknown
	msg_video
	msg_ctra
	msg_ctrb
	msg_rxa
	msg_txa
	msg_rxb
	msg_txb
	msg_cogram
	msg_error
	msg_ms
	msg_us
	msg_header
	msg_elapsed
	msg_ns
	msg_log_buffer_empty
	msg_invalid_view_number
	msg_invalid_value
	msg_macro_abort
	msg_no_test_data
	msg_src
	msg_dest
	msg_user
	msg_ptr
	msg_trace
	msg_options
	msg_option_help
	msg_carry
	msg_zero
	msg_set
	msg_cleared
	msg_dump_mode_help
	msg_ptr_help
	msg_effect_help
	msg_effect
	msg_execute
	msg_index
	msg_sequence
	msg_data
	msg_view_log
	msg_trace_width
	msg_32bit
	msg_16bit
	last_msg

	